X-Git-Url: https://git.rohieb.name/openwrt.git/blobdiff_plain/f89b5a949e6ecd1e8597d9a742ddaf73a7ae89c5..40ccc298bad9750af2ee579288dfd8def3286067:/package/base-files/files/lib/network/config.sh

diff --git a/package/base-files/files/lib/network/config.sh b/package/base-files/files/lib/network/config.sh
index 6ddbf9efe..e64198b7f 100755
--- a/package/base-files/files/lib/network/config.sh
+++ b/package/base-files/files/lib/network/config.sh
@@ -13,7 +13,7 @@ find_config() {
 		esac
 		config_get device "$ifn" device
 		for ifc in $device $iface $ifaces; do
-			[ "$ifc" = "$1" ] && {
+			[ ."$ifc" = ."$1" ] && {
 				echo "$ifn"
 				return 0
 			}
@@ -24,7 +24,7 @@ find_config() {
 }
 
 scan_interfaces() {
-	local mode iftype iface ifname device
+	local cfgfile="${1:-network}"
 	interfaces=
 	config_cb() {
 		case "$1" in
@@ -32,17 +32,19 @@ scan_interfaces() {
 				config_set "$2" auto 1
 			;;
 		esac
+		local iftype ifname device proto
 		config_get iftype "$CONFIG_SECTION" TYPE
 		case "$iftype" in
 			interface)
-				config_get proto "$CONFIG_SECTION" proto
 				append interfaces "$CONFIG_SECTION"
+				config_get proto "$CONFIG_SECTION" proto
 				config_get iftype "$CONFIG_SECTION" type
 				config_get ifname "$CONFIG_SECTION" ifname
-				config_set "$CONFIG_SECTION" device "$ifname"
+				config_get device "$CONFIG_SECTION" device "$ifname"
+				config_set "$CONFIG_SECTION" device "$device"
 				case "$iftype" in
 					bridge)
-						config_set "$CONFIG_SECTION" ifnames "$ifname"
+						config_set "$CONFIG_SECTION" ifnames "$device"
 						config_set "$CONFIG_SECTION" ifname br-"$CONFIG_SECTION"
 					;;
 				esac
@@ -50,121 +52,292 @@ scan_interfaces() {
 			;;
 		esac
 	}
-	config_load network
+	config_load "${cfgfile}"
 }
 
 add_vlan() {
 	local vif="${1%\.*}"
-	
+
 	[ "$1" = "$vif" ] || ifconfig "$1" >/dev/null 2>/dev/null || {
 		ifconfig "$vif" up 2>/dev/null >/dev/null || add_vlan "$vif"
 		$DEBUG vconfig add "$vif" "${1##*\.}"
+		return 0
 	}
+	return 1
 }
 
-setup_interface() {
+# sort the device list, drop duplicates
+sort_list() {
+	local arg="$*"
+	(
+		for item in $arg; do
+			echo "$item"
+		done
+	) | sort -u
+}
+
+# Create the interface, if necessary.
+# Return status 0 indicates that the setup_interface() call should continue
+# Return status 1 means that everything is set up already.
+
+prepare_interface() {
 	local iface="$1"
 	local config="$2"
-	local proto
-	local macaddr
+	local vifmac="$3"
 
-	[ -n "$config" ] || {
-		config=$(find_config "$iface")
-		[ "$?" = 0 ] || return 1
-	}
+	# if we're called for the bridge interface itself, don't bother trying
+	# to create any interfaces here. The scripts have already done that, otherwise
+	# the bridge interface wouldn't exist.
+	[ "br-$config" = "$iface" -o -e "$iface" ] && return 0;
 
-	proto="${3:-$(config_get "$config" proto)}"
-	config_get iftype "$config" type
-	
 	ifconfig "$iface" 2>/dev/null >/dev/null && {
-		# make sure the interface is removed from any existing bridge and brought down
-		ifconfig "$iface" down
+		local proto
+		config_get proto "$config" proto
+
+		# make sure the interface is removed from any existing bridge and deconfigured,
+		# (deconfigured only if the interface is not set to proto=none)
 		unbridge "$iface"
+		[ "$proto" = none ] || ifconfig "$iface" 0.0.0.0
+
+		# Change interface MAC address if requested
+		[ -n "$vifmac" ] && {
+			ifconfig "$iface" down
+			ifconfig "$iface" hw ether "$vifmac" up
+		}
 	}
 
 	# Setup VLAN interfaces
-	add_vlan "$iface"
+	add_vlan "$iface" && return 1
+	ifconfig "$iface" 2>/dev/null >/dev/null || return 0
 
 	# Setup bridging
+	local iftype
+	config_get iftype "$config" type
 	case "$iftype" in
 		bridge)
-			ifconfig "$iface" up 2>/dev/null >/dev/null
-			ifconfig "br-$config" 2>/dev/null >/dev/null && {
-				$DEBUG brctl addif "br-$config" "$iface"
-				return 0
-			} || {
-				$DEBUG brctl addbr "br-$config"
-				$DEBUG brctl setfd "br-$config" 0
-				$DEBUG brctl addif "br-$config" "$iface"
-				iface="br-$config"
+			[ -x /usr/sbin/brctl ] && {
+				ifconfig "br-$config" 2>/dev/null >/dev/null && {
+					local newdevs devices
+					config_get devices "$config" device
+					for dev in $(sort_list "$devices" "$iface"); do
+						append newdevs "$dev"
+					done
+					uci_set_state network "$config" device "$newdevs"
+					$DEBUG ifconfig "$iface" 0.0.0.0
+					$DEBUG brctl addif "br-$config" "$iface"
+					# Bridge existed already. No further processing necesary
+				} || {
+					local stp
+					config_get_bool stp "$config" stp 0
+					$DEBUG brctl addbr "br-$config"
+					$DEBUG brctl setfd "br-$config" 0
+					$DEBUG ifconfig "br-$config" up
+					$DEBUG ifconfig "$iface" 0.0.0.0
+					$DEBUG brctl addif "br-$config" "$iface"
+					$DEBUG brctl stp "br-$config" $stp
+					# Creating the bridge here will have triggered a hotplug event, which will
+					# result in another setup_interface() call, so we simply stop processing
+					# the current event at this point.
+				}
+				ifconfig "$iface" up 2>/dev/null >/dev/null
+				return 1
+			}
+		;;
+	esac
+	return 0
+}
+
+set_interface_ifname() {
+	local config="$1"
+	local ifname="$2"
+
+	local device
+	config_get device "$1" device
+	uci_set_state network "$config" ifname "$ifname"
+	uci_set_state network "$config" device "$device"
+}
+
+setup_interface_none() {
+	env -i ACTION="ifup" INTERFACE="$2" DEVICE="$1" PROTO=none /sbin/hotplug-call "iface" &
+}
+
+setup_interface_static() {
+	local iface="$1"
+	local config="$2"
+
+	local ipaddr netmask ip6addr
+	config_get ipaddr "$config" ipaddr
+	config_get netmask "$config" netmask
+	config_get ip6addr "$config" ip6addr
+	[ -z "$ipaddr" -o -z "$netmask" ] && [ -z "$ip6addr" ] && return 1
+
+	local gateway ip6gw dns bcast
+	config_get gateway "$config" gateway
+	config_get ip6gw "$config" ip6gw
+	config_get dns "$config" dns
+	config_get bcast "$config" broadcast
+
+	[ -z "$ipaddr" ] || $DEBUG ifconfig "$iface" "$ipaddr" netmask "$netmask" broadcast "${bcast:-+}"
+	[ -z "$ip6addr" ] || $DEBUG ifconfig "$iface" add "$ip6addr"
+	[ -z "$gateway" ] || $DEBUG route add default gw "$gateway" dev "$iface"
+	[ -z "$ip6gw" ] || $DEBUG route -A inet6 add default gw "$ip6gw" dev "$iface"
+	[ -z "$dns" ] || {
+		for ns in $dns; do
+			grep "$ns" /tmp/resolv.conf.auto 2>/dev/null >/dev/null || {
+				echo "nameserver $ns" >> /tmp/resolv.conf.auto
 			}
+		done
+	}
+
+	config_get type "$config" TYPE
+	[ "$type" = "alias" ] && return 0
+
+	env -i ACTION="ifup" INTERFACE="$config" DEVICE="$iface" PROTO=static /sbin/hotplug-call "iface" &
+}
+
+setup_interface_alias() {
+	local config="$1"
+	local parent="$2"
+	local iface="$3"
+
+	local cfg
+	config_get cfg "$config" interface
+	[ "$parent" == "$cfg" ] || return 0
+
+	# alias counter
+	local ctr
+	config_get ctr "$parent" alias_count 0
+	ctr="$(($ctr + 1))"
+	config_set "$parent" alias_count "$ctr"
+
+	# alias list
+	local list
+	config_get list "$parent" aliases
+	append list "$config"
+	config_set "$parent" aliases "$list"
+
+	iface="$iface:$ctr"
+	set_interface_ifname "$config" "$iface"
+
+	local proto
+	config_get proto "$config" proto "static"
+	case "${proto}" in
+		static)
+			setup_interface_static "$iface" "$config"
+		;;
+		*)
+			echo "Unsupported type '$proto' for alias config '$config'"
+			return 1
 		;;
 	esac
-	
+}
+
+setup_interface() {
+	local iface_main="$1"
+	local config="$2"
+	local proto="$3"
+	local vifmac="$4"
+	local ip6addr_main=
+
+	[ -n "$config" ] || {
+		config=$(find_config "$iface_main")
+		[ "$?" = 0 ] || return 1
+	}
+
+	prepare_interface "$iface_main" "$config" "$vifmac" || return 0
+
+	[ "$iface_main" = "br-$config" ] && {
+		# need to bring up the bridge and wait a second for
+		# it to switch to the 'forwarding' state, otherwise
+		# it will lose its routes...
+		ifconfig "$iface_main" up
+		sleep 1
+	}
+
 	# Interface settings
-	config_get mtu "$config" mtu
-	config_get macaddr "$config" macaddr
-	$DEBUG ifconfig "$iface" ${macaddr:+hw ether "$macaddr"} ${mtu:+mtu $mtu} up
+	grep "$iface_main:" /proc/net/dev > /dev/null && {
+		local mtu macaddr
+		config_get mtu "$config" mtu
+		config_get macaddr "$config" macaddr
+		[ -n "$macaddr" ] && $DEBUG ifconfig "$iface_main" down
+		$DEBUG ifconfig "$iface_main" ${macaddr:+hw ether "$macaddr"} ${mtu:+mtu $mtu} up
+	}
+	set_interface_ifname "$config" "$iface_main"
 
-	pidfile="/var/run/$iface.pid"
+	pidfile="/var/run/$iface_main.pid"
+	[ -n "$proto" ] || config_get proto "$config" proto
 	case "$proto" in
 		static)
-			config_get ipaddr "$config" ipaddr
-			config_get netmask "$config" netmask
-			[ -z "$ipaddr" -o -z "$netmask" ] && return 1
-			
-			config_get ip6addr "$config" ip6addr
-			config_get gateway "$config" gateway
-			config_get dns "$config" dns
-			
-			$DEBUG ifconfig "$iface" "$ipaddr" netmask "$netmask"
-			[ -z "$gateway" ] || route add default gw "$gateway"
-			[ -z "$dns" -o -f /tmp/resolv.conf ] || {
-				for ns in $dns; do
-					echo "nameserver $ns" >> /tmp/resolv.conf
-				done
-			}
-
-			env -i ACTION="ifup" INTERFACE="$config" DEVICE="$iface" PROTO=static /sbin/hotplug "iface" &
+			config_get ip6addr_main "$config" ip6addr
+			setup_interface_static "$iface_main" "$config"
 		;;
 		dhcp)
 			# prevent udhcpc from starting more than once
-			lock "/var/lock/dhcp-$iface"
-			pid="$(cat "$pidfile" 2>/dev/null)"
-			[ -d "/proc/$pid" ] && grep udhcpc "/proc/${pid}/cmdline" >/dev/null 2>/dev/null && {
-				lock -u "/var/lock/dhcp-$iface"
-				return 0
-			}
-
-			config_get ipaddr "$config" ipaddr
-			config_get netmask "$config" netmask
-			config_get hostname "$config" hostname
-			config_get proto1 "$config" proto
+			lock "/var/lock/dhcp-$iface_main"
+			local pid="$(cat "$pidfile" 2>/dev/null)"
+			if [ -d "/proc/$pid" ] && grep udhcpc "/proc/${pid}/cmdline" >/dev/null 2>/dev/null; then
+				lock -u "/var/lock/dhcp-$iface_main"
+			else
+				local ipaddr netmask hostname proto1 clientid
+				config_get ipaddr "$config" ipaddr
+				config_get netmask "$config" netmask
+				config_get hostname "$config" hostname
+				config_get proto1 "$config" proto
+				config_get clientid "$config" clientid
 
-			[ -z "$ipaddr" ] || \
-				$DEBUG ifconfig "$iface" "$ipaddr" ${netmask:+netmask "$netmask"}
+				[ -z "$ipaddr" ] || \
+					$DEBUG ifconfig "$iface_main" "$ipaddr" ${netmask:+netmask "$netmask"}
 
-			# don't stay running in background if dhcp is not the main proto on the interface (e.g. when using pptp)
-			[ "$proto1" != "$proto" ] && dhcpopts="-n -q"
-			$DEBUG eval udhcpc -t 0 -i "$iface" ${ipaddr:+-r $ipaddr} ${hostname:+-H $hostname} -b -p "$pidfile" ${dhcpopts:- -R &}
-			lock -u "/var/lock/dhcp-$iface"
+				# don't stay running in background if dhcp is not the main proto on the interface (e.g. when using pptp)
+				local dhcpopts
+				[ ."$proto1" != ."$proto" ] && dhcpopts="-n -q"
+				$DEBUG eval udhcpc -t 0 -i "$iface_main" ${ipaddr:+-r $ipaddr} ${hostname:+-H $hostname} ${clientid:+-c $clientid} -b -p "$pidfile" ${dhcpopts:- -O rootpath -R &}
+				lock -u "/var/lock/dhcp-$iface_main"
+			fi
+		;;
+		none)
+			setup_interface_none "$iface_main" "$config"
 		;;
 		*)
 			if ( eval "type setup_interface_$proto" ) >/dev/null 2>/dev/null; then
-				eval "setup_interface_$proto '$iface' '$config' '$proto'" 
+				eval "setup_interface_$proto '$iface_main' '$config' '$proto'"
 			else
 				echo "Interface type $proto not supported."
 				return 1
 			fi
 		;;
 	esac
+	[ "$proto" = none ] || {
+		for ifn in `ifconfig | grep "^$iface_main:" | awk '{print $1}'`; do
+			ifconfig "$ifn" down
+		done
+	}
+
+	local aliases
+	config_set "$config" aliases ""
+	config_set "$config" alias_count 0
+	config_foreach setup_interface_alias alias "$config" "$iface_main"
+	config_get aliases "$config" aliases
+	[ -z "$aliases" ] || uci_set_state network "$config" aliases "$aliases"
+
+	# put the ip6addr back to the beginning to become the main ip again
+	[ -z "$ip6addr_main" ] || {
+		$DEBUG ifconfig "$iface_main" del "$ip6addr_main"
+		$DEBUG ifconfig "$iface_main" add "$ip6addr_main"
+	}
+}
+
+stop_interface_dhcp() {
+	local config="$1"
+	uci -P /var/state revert "network.$config"
 }
 
 unbridge() {
 	local dev="$1"
 	local brdev
 
-	brctl show | grep "$dev" >/dev/null && {
+	[ -x /usr/sbin/brctl ] || return 0
+	brctl show 2>/dev/null | grep "$dev" >/dev/null && {
 		# interface is still part of a bridge, correct that
 
 		for brdev in $(brctl show | awk '$2 ~ /^[0-9].*\./ { print $1 }'); do